## hailo-dkms 4.17.0

=== debian/changelog ===
hailo-dkms (4.17.0-2) bookworm; urgency=medium

  * Add hailofw dependency
  * Version firmware file

 -- Serge Schneider <serge@raspberrypi.com>  Fri, 15 Nov 2024 10:55:24 +0000

hailo-dkms (4.17.0-1) bookworm; urgency=medium

  * Initial release.

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 21 Aug 2024 11:14:28 +0000
