=== debian/control ===
Source: hailo-dkms
Section: kernel
Priority: optional
Maintainer: Serge Schneider <serge@raspberrypi.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-dkms,
Standards-Version: 4.6.2
Homepage: https://github.com/hailo-ai/hailort-drivers/

Package: hailo-dkms
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 hailofw (>= 4.17.0),
Description: Hailo PCIe driver
 Hailo PCIe driver required for interacting with a Hailo device over the PCIe
 interface
