## hailo-dkms 4.18.0

=== debian/changelog ===
hailo-dkms (4.18.0-2) bookworm; urgency=medium

  * Include firmware version in the expected filename
  * Refresh install-conf-only.patch

 -- Serge Schneider <serge@raspberrypi.com>  Thu, 14 Nov 2024 16:07:25 +0000

hailo-dkms (4.18.0-1) bookworm; urgency=medium

  * New upstream version 4.18.0

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 21 Aug 2024 14:53:55 +0100
