## hailo-dkms 4.19.0

=== debian/changelog ===
hailo-dkms (4.19.0-1) bookworm; urgency=medium

  * New upstream version 4.19.0
  * d/patches: Refresh patches
  * Include firmware version in the expected filename
  * Add hailofw dependency

 -- Serge Schneider <serge@raspberrypi.com>  Fri, 15 Nov 2024 11:03:14 +0000
