## hailo-dkms 4.20.0

=== debian/changelog ===
hailo-dkms (4.20.0-1) bookworm; urgency=medium

  * New upstream version 4.20.0
  * Update hardcode_fw_name.patch

 -- Serge Schneider <serge@raspberrypi.com>  Mon, 27 Jan 2025 19:11:26 +0000
