=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- hailofw (>= 4.18.0),
+ hailofw (>= 4.19.0),
 Description: Hailo PCIe driver
  Hailo PCIe driver required for interacting with a Hailo device over the PCIe
  interface
